<template>
  <div>
    <div id="search-app" class="container">
    <!-- Search form section -->
    <section class="my-5 row justify-content-center">
            <div class="col-md-6">
                <div class="input-group mb-3">
                    <input type="text" v-model="q" class="form-control" placeholder="Search ..." aria-label="Recipient's username" aria-describedby="basic-addon2">
                    <div class="input-group-append">
                        <button class="btn btn-secondary" type="button">
                          <b-icon icon="search"></b-icon>
                        </button>
                    </div>
                </div>
            </div>
    </section>
    </div>
    
    <b-container class="bv-example-row">
      <b-row align-h="center">
        <div>
          <b-col>
            <b-card v-for="nws in filteredNews" :key="nws.id"
            :title="nws.title"
            :img-src="nws.urlToImage"
            img-alt=""
            img-top
            tag="article"
            style="max-width:60rem; margin-bottom: 40px">
              <!-- {{ news }} -->
            <b-card-text style="text-align: left">
              <!-- {{ nws.description }} -->
              {{ nws.content }}
            </b-card-text>
            <b-button variant="dark" :href="nws.url">Read More</b-button>
            </b-card>
          </b-col>
        </div>

      </b-row>
    </b-container>
  </div>
</template>

<script>
export default {
  components: { 
    // "news-card": newsCard 
    // "search-bar": searchBar
  },
  mounted(){
    this.fetchData();
  },
  data(){
    return{
      news: [],
      q: ""
    }
  },
  methods:{
        async fetchData(){
            var q = "";
            if(this.query != null || this.query != undefined){
                q = this.query;
            }
            await this.axios({
                method: "get",
                url: `https://newsapi.org/v2/top-headlines?q=${q}&country=us&category=technology`,
                headers:{
                    "X-Api-Key":"c4ab28a21ce44cc680ce08840f838557"
                } 
            })
            .then((response) => {
                if(response.data.totalResults > 0){
                    this.news = response.data.articles;
                    console.log(this.news);

                }else{
                    alert("no data")
                }
            })
            .catch((e) => {
                this.errors.push(e);
            });
        }
    // async fetchData(){
    //   await this.axios({
    //   method: "get",
    //   url: `https://newsapi.org/v2/top-headlines?category=technology&apiKey=c4ab28a21ce44cc680ce08840f838557`, })
    //   .then((response) => {
    //     // JSON responses are automatically parsed.
    //   this.news = response.data.articles;
    //   console.log(this.news);
    //   });
    // }
  },
  // visitPage(){
  //   window.location={{ nws.url }};
  // }
  computed:{
    filteredNews: function(){
      return this.news.filter((nws) => {
        return nws.title.match(this.q);
      });
    }
  }

};

</script>